'use strict';

exports.__esModule = true;

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _mkI18n = require('mk-element-ui2/lib/datas/mk-i18n');

var _mkI18n2 = _interopRequireDefault(_mkI18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var install = function install(Vue, store) {
  Vue.filter('dataI18n', function (value) {
    return _mkI18n2.default.findI18n(value);
  });
  Vue.filter('dataI18nIf', function (value) {
    var flag = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

    if (flag === false) {
      return '';
    } else {
      return _mkI18n2.default.findI18n(value);
    }
  });
  Vue.filter('dataI18nIfElse', function (value, value2) {
    var flag = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    if (flag === true) {
      return _mkI18n2.default.findI18n(value);
    } else {
      return _mkI18n2.default.findI18n(value2);
    }
  });
  Vue.filter('dataConfig', function (value, configName, def) {
    try {
      return store.state.config.GlobalMap[configName][value] || def;
    } catch (e) {
      return def;
    }
  });
  Vue.filter('dataConfigs', function (value) {
    for (var _len = arguments.length, configNames = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      configNames[_key - 1] = arguments[_key];
    }

    try {
      for (var _iterator = configNames, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var configName = _ref;

        var label = store.state.config.GlobalMap[configName][value];
        if (label !== undefined) {
          return label;
        }
      }
      return '';
    } catch (e) {
      return '';
    }
  });
};
exports.default = {
  install: install
};