'use strict';

exports.__esModule = true;

var _vuex = require('vuex');

var _mkI18n = require('mk-element-ui2/lib/datas/mk-i18n');

var _mkI18n2 = _interopRequireDefault(_mkI18n);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 通用vue模版
 * */
exports.default = {
  computed: (0, _vuex.mapState)({
    user: 'user',
    basePath: 'basePath',
    config: 'config',
    wsPath: 'wsPath',
    token: 'token',
    viewAction: 'viewAction',
    uploadAction: 'uploadAction'
  }),
  methods: {
    BIND_USER: (0, _vuex.mapMutations)(['BIND_USER']).BIND_USER,
    BIND_LOADING: (0, _vuex.mapMutations)(['BIND_LOADING']).BIND_LOADING,
    i18n: function i18n(key) {
      var keys = key.split('.');
      var i = 0;
      var j = keys.length;
      var obj = _mkI18n2.default;

      while (obj !== undefined && i < j) {
        obj = obj[keys[i++]];
      }
      return obj;
    }
  },
  mounted: function mounted() {
    this.BIND_LOADING(false);
  },
  activated: function activated() {
    this.BIND_LOADING(false);
  }
};