'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _vueAxios = require('vue-axios');

var _vueAxios2 = _interopRequireDefault(_vueAxios);

var _mkCacheUtil = require('mk-element-ui2/lib/utils/mk-cache-util');

var _mkCacheUtil2 = _interopRequireDefault(_mkCacheUtil);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var actMessages = ['Okay', 'Created']; /* eslint-disable */

var install = function install(Vue, _ref) {
  var _ref$baseURL = _ref.baseURL,
      baseURL = _ref$baseURL === undefined ? '/' : _ref$baseURL,
      _ref$timeout = _ref.timeout,
      timeout = _ref$timeout === undefined ? 50000 : _ref$timeout,
      _ref$productMode = _ref.productMode,
      productMode = _ref$productMode === undefined ? false : _ref$productMode,
      _ref$productErrorTip = _ref.productErrorTip,
      productErrorTip = _ref$productErrorTip === undefined ? 'sorry，系统发生错误！' : _ref$productErrorTip,
      _ref$defaultTip = _ref.defaultTip,
      defaultTip = _ref$defaultTip === undefined ? '未知错误' : _ref$defaultTip,
      _ref$sessionTimeoutCo = _ref.sessionTimeoutCode,
      sessionTimeoutCode = _ref$sessionTimeoutCo === undefined ? '201001' : _ref$sessionTimeoutCo,
      _ref$loginPath = _ref.loginPath,
      loginPath = _ref$loginPath === undefined ? '/login' : _ref$loginPath,
      _ref$systemErrorCodeS = _ref.systemErrorCodeStartWith,
      systemErrorCodeStartWith = _ref$systemErrorCodeS === undefined ? 1 : _ref$systemErrorCodeS;

  var axiosInstance = _axios2.default.create({
    baseURL: baseURL,
    timeout: timeout,
    responseType: 'json',
    withCredentials: true,
    headers: {
      'Content-Type': 'application/json;charset=utf-8',
      Accept: 'application/json'
    },
    validateStatus: function validateStatus(status) {
      return status < 500;
    }
  });
  axiosInstance.interceptors.request.use(function (config) {
    var devid = _mkCacheUtil2.default.get(_mkCacheUtil2.default.keys.devid);
    config.headers.devid = devid;
    return config;
  },
  // eslint-disable-next-line no-undef
  function (error) {
    return _promise2.default.reject(error);
  });
  axiosInstance.interceptors.response.use(function (response) {
    return response;
  },
  // eslint-disable-next-line no-undef
  function (error) {
    return _promise2.default.reject(error);
  });
  Vue.use(_vueAxios2.default, axiosInstance);
  var axiosHandelExcption = function axiosHandelExcption(_ref2) {
    var _ref2$message = _ref2.message,
        message = _ref2$message === undefined ? defaultTip : _ref2$message,
        _ref2$status = _ref2.status,
        status = _ref2$status === undefined ? 500 : _ref2$status,
        url = _ref2.url;

    // 非用户异常
    var type = 'warning';
    if (status.toString().startsWith('' + systemErrorCodeStartWith)) {
      type = 'error';
      if (productMode === true) {
        message = productErrorTip;
      }
    }
    if (productMode === false) {
      message = message + '(' + status + ') ' + url;
    }
    Vue.prototype.$message({
      showClose: true,
      message: message,
      type: type
    });
    if (status === sessionTimeoutCode) {
      return Vue.prototype.$router.push(loginPath);
    }
    // eslint-disable-next-line
    throw {
      status: status,
      message: message
    };
  };
  var axiosHandel = function axiosHandel(response, url) {
    if (response.status - 300 > 0) {
      axiosHandelExcption({
        message: response.data.message,
        status: response.status,
        url: url
      });
    } else if (response.data.status || response.data.message && actMessages.indexOf(response.data.message) === -1) {
      axiosHandelExcption({
        message: response.data.message,
        status: response.data.status || response.status,
        url: url
      });
    } else {
      return response.data;
    }
  };

  Vue.prototype.$post = function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(url, params) {
      var response;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              response = void 0;
              _context.prev = 1;
              _context.next = 4;
              return axiosInstance.post(url, params);

            case 4:
              response = _context.sent;
              _context.next = 10;
              break;

            case 7:
              _context.prev = 7;
              _context.t0 = _context['catch'](1);

              axiosHandelExcption({
                msg: _context.t0.message,
                url: url
              });

            case 10:
              return _context.abrupt('return', axiosHandel(response, url));

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined, [[1, 7]]);
    }));

    return function (_x, _x2) {
      return _ref3.apply(this, arguments);
    };
  }();
  Vue.prototype.$get = function () {
    var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(url, params) {
      var response;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              response = void 0;
              _context2.prev = 1;
              _context2.next = 4;
              return axiosInstance.get(url, {
                params: params
              });

            case 4:
              response = _context2.sent;
              _context2.next = 10;
              break;

            case 7:
              _context2.prev = 7;
              _context2.t0 = _context2['catch'](1);

              axiosHandelExcption({
                msg: _context2.t0.message,
                url: url
              });

            case 10:
              return _context2.abrupt('return', axiosHandel(response, url));

            case 11:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined, [[1, 7]]);
    }));

    return function (_x3, _x4) {
      return _ref4.apply(this, arguments);
    };
  }();
  Vue.prototype.$delete = function () {
    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(url, params) {
      var response;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              response = void 0;
              _context3.prev = 1;
              _context3.next = 4;
              return axiosInstance.delete(url, {
                params: params
              });

            case 4:
              response = _context3.sent;
              _context3.next = 10;
              break;

            case 7:
              _context3.prev = 7;
              _context3.t0 = _context3['catch'](1);

              axiosHandelExcption({
                msg: _context3.t0.message,
                url: url
              });

            case 10:
              return _context3.abrupt('return', axiosHandel(response, url));

            case 11:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined, [[1, 7]]);
    }));

    return function (_x5, _x6) {
      return _ref5.apply(this, arguments);
    };
  }();
  Vue.prototype.$put = function () {
    var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(url, params) {
      var response;
      return _regenerator2.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              response = void 0;
              _context4.prev = 1;
              _context4.next = 4;
              return axiosInstance.put(url, params);

            case 4:
              response = _context4.sent;
              _context4.next = 10;
              break;

            case 7:
              _context4.prev = 7;
              _context4.t0 = _context4['catch'](1);

              axiosHandelExcption({
                msg: _context4.t0.message,
                url: url
              });

            case 10:
              return _context4.abrupt('return', axiosHandel(response, url));

            case 11:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, undefined, [[1, 7]]);
    }));

    return function (_x7, _x8) {
      return _ref6.apply(this, arguments);
    };
  }();
};

exports.default = {
  install: install
};