'use strict';

exports.__esModule = true;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _mutations = require('./mutations');

var _mutations2 = _interopRequireDefault(_mutations);

var _action = require('./action');

var _action2 = _interopRequireDefault(_action);

var _getters = require('./getters');

var _getters2 = _interopRequireDefault(_getters);

var _state = require('./state');

var _state2 = _interopRequireDefault(_state);

var _mutationTypes = require('./mutation-types');

var mutationTypes = _interopRequireWildcard(_mutationTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var store = {
  state: _state2.default,
  getters: _getters2.default,
  actions: _action2.default,
  mutations: _mutations2.default,
  transform: function transform(vuexStore, _ref) {
    var basePath = _ref.basePath,
        baseTitle = _ref.baseTitle,
        index = _ref.index,
        wsPath = _ref.wsPath,
        token = _ref.token,
        uploadAction = _ref.uploadAction,
        viewAction = _ref.viewAction;

    vuexStore.commit(mutationTypes.BIND_BASEPATH, basePath);
    vuexStore.commit(mutationTypes.BIND_TITLE, baseTitle);
    vuexStore.commit(mutationTypes.BIND_INDEX, index);
    vuexStore.commit(mutationTypes.BIND_WSPATH, wsPath);
    vuexStore.commit(mutationTypes.BIND_TOKEN, token);
    vuexStore.commit(mutationTypes.BIND_VIEW_ACTION, viewAction);
    vuexStore.commit(mutationTypes.BIND_UPLOAD_ACTION, uploadAction);
  }
};
(0, _assign2.default)(store, mutationTypes);
exports.default = store;