"use strict";

exports.__esModule = true;
/**
 * option对象
 * source : 源数据
 * key : 数据的主键名称
 * label：转为label的字段名称
 * children：转为children的字段名称
 * disabledarr : 不可选择列表
 * return：返回所有key的列表
 */
var recursionTree = function recursionTree(option) {
  var result = [];

  if (!option) {
    return result;
  }
  if (!(option.source instanceof Array)) {
    return result;
  }
  var source = option.source;
  var key = option.key;
  var label = option.label;
  var children = option.children;
  var disabledarr = option.disabledarr || [];

  var _loop = function _loop(i) {
    var o = source[i];

    if (key) {
      result.push(o[key]);
    }
    o.label = o[label];
    if (key) {
      o.id = o[key];
    }

    var index = disabledarr.findIndex(function (n) {
      return n === o.id;
    });

    if (index > -1) {
      o.disabled = true;
      disabledarr.splice(index, 1);
    }

    if (o[children] && o[children].length > 0) {
      var suboption = {
        source: o[children],
        key: key,
        label: label,
        children: children,
        disabledarr: disabledarr
      };

      recursionTree(suboption);
      o.children = o[children];
      o[children] = [];
    }
  };

  for (var i in source) {
    _loop(i);
  }
  return result;
};

exports.default = recursionTree;