import i18n from 'mk-element-ui2/src/datas/mk-i18n';
const install = (Vue, store) => {
  Vue.filter('dataI18n', value => i18n.findI18n(value));
  Vue.filter('dataI18nIf', (value, flag = true) => {
    if (flag === false) {
      return '';
    } else {
      return i18n.findI18n(value);
    }
  });
  Vue.filter('dataI18nIfElse', (value, value2, flag = true) => {
    if (flag === true) {
      return i18n.findI18n(value);
    } else {
      return i18n.findI18n(value2);
    }
  });
  Vue.filter('dataConfig', (value, configName, def) => {
    try {
      return store.state.config.GlobalMap[configName][value] || def;
    } catch (e) {
      return def;
    }
  });
  Vue.filter('dataConfigs', (value, ...configNames) => {
    try {
      for (let configName of configNames) {
        const label = store.state.config.GlobalMap[configName][value];
        if (label !== undefined) {
          return label;
        }
      }
      return '';
    } catch (e) {
      return '';
    }
  });
};
export default {
  install
};
